#include <iostream>
#include "dyn"

static const double G  = 6.673e-11;  /* Nm/kg */ 
static const double PI = 3.141592653589793238462643383279502884197169399375;
static const double PI2 = PI*2;

static void SatFun()
{
    dyn<double> satmass = 0;  /* kg */

    dyn<double> dist     = 295000;   /* km */
    dyn<double> centmass = 5.68e26;  /* kg */
    
    dyn<double> time = dist / sqrt((satmass + centmass) * (G / 1000) / dist) * (PI2 / 86.4);
    
    satmass  = 35e13;    /* kg = Calypso */
    std::cout << "Calypso: " << time.getvalue() << " days ("; time.debug(); std::cout << ")\n";

    satmass  = 54e13;    /* kg = Telesto */
    std::cout << "Telesto: " << time.getvalue() << " days ("; time.debug(); std::cout << ")\n";

    satmass  = 6.22e20;  /* kg = Tethys */
    std::cout << "Tethys: " << time.getvalue() << " days ("; time.debug(); std::cout << ")\n";
}

int main(void)
{
    try {
        SatFun();
    } catch(dynerror tmp)
    {
        std::cerr << tmp << std::endl;
    }
    return 0;
}
